
import os, sys

DATA_DIR = os.path.join("experiment", "utilisation_scan")

def process(nts, data_dir = DATA_DIR,
        end = ".ideal.csv", number_scale = 1, nts_out = None):
    max_tasks = 0
    out = []
    for name in os.listdir(data_dir):
        if not name.endswith(end):
            continue
        if not name.startswith(nts):
            continue

        total = 0
        counters = dict()
        for line in file(os.path.join(data_dir, name)):
            fields = line.split()
            u = float(fields[1])
            for i in xrange(2, len(fields)):
                counters[i] = counters.get(i, 0) + (float(fields[i]) * u)

            max_tasks = max(float(fields[2]), max_tasks)
            total += max_tasks * u

        number = float(int(name[len(nts):-len(end)], 10)) * number_scale
        out_line = []
        out_line.append('%10.3f' % number)
        i = 2
        while counters.has_key(i):
            c = counters[i] / total
            out_line.append('%1.4f' % c)
            i += 1

        out.append(' '.join(out_line))

    out.sort()
    assert len(out) != 0

    if nts_out != None:
        nts = nts_out

    out.append("\n")
    file("wu-%s.dat" % nts, "wt").write('\n'.join(out))

    rc = os.system("gnuplot wu-%s.gnuplot > figures/wu-%s.ps" % (nts, nts))
    assert rc == 0
    rc = os.system("ps2pdf14 figures/wu-%s.ps figures/wu-%s.pdf" % (nts, nts))
    assert rc == 0


